new function(fs, path){

this.FileCopy = function(colors, makeDirs){
	return class FileCopy {
		constructor(paths){
			for(let from in paths){
				let filename, result, to = paths[from], toPath = path.parse(to), fromPath = path.parse(from);

				result = toPath.ext ? to : `${to}/${fromPath.base + (fromPath.ext ? "" : ".js")}`;

				try {
					filename = require.resolve(from);
				}
				catch(e){
					console.log(
						colors.bgBlue("找不到指定文件：") + colors.red(from)
					);
					return;
				}

				try {
					makeDirs(result, makeDirs);

					fs.writeFileSync(
						result,
						fs.readFileSync(filename)
					);
				}
				catch(e){
					console.log(
						colors.bgBlue("写入文件失败：") + colors.red(e)
					);
					return;
				}

				console.log(
					colors.green("文件已复制：") + colors.yellow(result)
				);
			}
		};
	};
}(
	require("colors/safe"),
	// makeDirs
	(dirname, callee) => {
		let p = path.parse(dirname), dir = p.ext ? p.dir : dirname;

		try {
			if(fs.statSync(dir).isDirectory()){
				return;
			}
		}
		catch(e){
			callee(
				path.resolve(dir, "../"),
				callee
			);
		}

		fs.mkdirSync(dir);
	}
);

module.exports = this.FileCopy;
}(
	require("fs"),
	require("path")
);